package ru.dbotthepony.kstarbound.world

import ru.dbotthepony.kstarbound.util.readVec2i
import ru.dbotthepony.kstarbound.util.writeVec2i
import ru.dbotthepony.kvector.vector.Vector2i
import java.io.DataInputStream
import java.io.DataOutputStream

data class WorldGeometry(val size: Vector2i, val loopX: Boolean, val loopY: Boolean) {
	constructor(buff: DataInputStream) : this(buff.readVec2i(), buff.readBoolean(), buff.readBoolean())

	val x: CoordinateMapper = if (loopX) CoordinateMapper.Wrapper(size.x) else CoordinateMapper.Clamper(size.x)
	val y: CoordinateMapper = if (loopY) CoordinateMapper.Wrapper(size.y) else CoordinateMapper.Clamper(size.y)

	fun write(buff: DataOutputStream) {
		buff.writeVec2i(size)
		buff.writeBoolean(loopX)
		buff.writeBoolean(loopY)
	}
}
